'program przeznaczony do wsppracy z dwoma czujnikami DS18B210 podczonymi do magistrali 1Wire
$regfile = "m32def.dat"
'XTAL
$crystal = 16000000

Deflcdchar 0 , 12 , 18 , 18 , 12 , 32 , 32 , 32 , 32        ' deklaracje znakw specjalnych

Config Lcdpin = Pin , Db4 = Porta.2 , Db5 = Porta.3 , Db6 = Porta.4 , Db7 = Porta.5 , E = Porta.1 , Rs = Porta.0
Config 1wire = Portc.0                                      'konfiguracja pinu 1Wire

Dim Nr_ukladu(8) As Byte                                    'tablica do przechowywania nr 1 ukadu
Dim Nr_ukladu2(8) As Byte                                   'tablica do przechowywania nr 2 ukadu
Dim Biezacy(8) As Byte                                      'tablica do przechowywania nr aktualnie odczytywaniego ukadu
Dim I As Byte , A As Byte                                   'zmienne pomocnicze
Dim T(2) As Byte                                            'tabliac przechowujca odczytane z czujnika wartoci
Dim Temp As Integer                                         'temperatura cakowita
Dim Ulamek As Integer                                       'cz uamkowa
Declare Sub Czytaj                                          'procedura odczytu
Declare Sub Wybierz_uklad                                   'procedura wyboru ukadu do odczytu

Cls                                                         'kasujemy LCD

Do                                                          'ptla gwna
   1wreset                                                  'reset magistrali 1wire
   If Err = 1 Then                                          'jezeli uklad dolaczony do magistali nie odpowiada do err=1 i
         Cls                                                'czysc LCD
         Lcd "Brak ukladu"                                  'wyswietl komunikat
         Do
            1wreset
         Loop Until Err = 0                                 'petla do-loop w celu wstrzymania programu do czasu podlaczenia urzadzenia
   End If

   Nr_ukladu(1) = 1wsearchfirst()                           'pobieramy nr pierwszego ukadu
   Nr_ukladu2(1) = 1wsearchnext()                           'pobieramy nr drugiego ukadu

  For A = 1 To 2                                            'odczytujemy po kolei temp z czujnikw
      If A = 1 Then Locate 1 , 1 Else Locate 2 , 1          'jeli czujnik pierwszy to ustawiamy kursor w 1 linii, jeli 2 to w drugiej
      Call Czytaj                                           'odczytanie temperatury w procedurze
      Lcd "T(" ; A ; "):" ;                                 'wyswietlenie nr czujnika i temperatury cakowitej
      If I = 1 Then Lcd "-";
      Lcd Temp ; ".";
      If Ulamek = 625 Then Lcd "0";

                               'uporzdkowanie uamka
      Lcd Ulamek ; Chr(0) ; "C       "                      ' wywietlenie uamka i symbolu stopie
  Next A
Loop                                                        'koniec ptli gwnej

Sub Czytaj                                                  'proceduta odczytu

   1wreset                                                  'reset magistrali 1wire
   For I = 1 To 8                                           'wybr nr ukadu do odczytania
      If A = 1 Then Biezacy(i) = Nr_ukladu(i)
      If A = 2 Then Biezacy(i) = Nr_ukladu2(i)
   Next

   Call Wybierz_uklad                                       'wywoanie ukadu
   1wwrite &H44                                             'Polecenie konwersji temperatury
   Waitms 750                                               'czas konwersji zgodnie z kart katalogow
   1wreset                                                  'reset magistrali 1wire
   Call Wybierz_uklad                                       'wywoanie ukadu
   1wwrite &HBE                                             'danie odczytania temperatury
   T(1) = 1wread()                                          'odczytaj z magistrali 1WIRE 1 bajt
   T(2) = 1wread()                                          'odczytaj z magistrali 1WIRE 2 bajt
   1wreset                                                  'reset magistrali 1wire
'Wynik w DS18B20 jest zapisaywany w dwch bajtach. High=SSSS SHHH, Low = HHHH LLLL,
'gdzie S-znak, H-bity czesci cakowitej pomiaru temperatury w stopniach [C],
'L-bity wyniku po przecinku (L*0,0625 [C]).
'czyli najlepiej  trzeba zczy w jeden bajt bity SHHH oraz HHHH co da temperatur zapisan wprost
'na 7 bajtach (H) - jeli bdzie ujemna wtedy S = 1 i naley j przeliczy: 255-0HHHHHH
'Dodatkowo naley z bajtu Low usun cz HHHH i pozostanie 0000LLLL czyli cz uamkowa
'to co pozostanie naley pomnoy przez 0,0625 s (rozdzielczo maksymalna)
'procedura ponisza jest uniewrsalna i dziaa dobrze dla kadej ustawionej rozdzielczoci czujnika
'od 9 do 12 bitw

'dane z karty kat. mozna podstawic do sprawdzenia
' T(2) = &HFF                                                '   -10,125
'  T(1) = &H5E
'  T(2) = &H01                                               '+ 25 , 0625
'  T(1) = &H91
' T(2) = &H00   '   +10,125
' T(1) = &HA2
'T(2) = &HFE                                                 '  -25,0625
'T(1) = &H6F
' T(2) = &HFF                                                '   -0,5
' T(1) = &HF8
' T(2) = &H00                                                '   +0,5
' T(1) = &H08

' T(2) = &H00                                                '   +0,5
' T(1) = &H00


Temp = Makeint(t(1) , T(2))                                 'czymy bajty w zmienn typu INTEGER (-32,768 Do +32,767)
Temp = Temp / 16                                            ' pozbywamy si czci uamkowej

If T(2) = &HFF And T(1) > &HF0 Then I = 1                   'zmienna I jest tu wykorzystana jako wskaznik znaku temperatury miedzy -1 a 1 stopien
                                                            'poniewaz czesc calkowita wynosi 0 (bez znaku)
T(1) = T(1) * 16                                            ' tu obliczamy  uamek - pozbywamy si 4 najstarszych bitw
T(1) = T(1) / 16
Ulamek = T(1) * 625                                         ' mnoymy przez rozdzielczo czujnika
If T(2) > 127 Then Ulamek = 10000 - Ulamek                  ' jeli temp ujemna to przeliczamy cz uamkow
                                                     ' i nie jest w aden sposb zwizana z procedur odczytu z czujnikw
End Sub



Sub Wybierz_uklad
1wwrite &H55                                                'Wybr ukadu
For I = 1 To 8
    1wwrite Biezacy(i)                                      'urzdzenia o numerze nr_ukladu.
Next I
End Sub